VERSION 5.00
Begin VB.Form frmAdminConsole_UserAccounts_CreateNew 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Create New User Account"
   ClientHeight    =   2565
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6045
   HelpContextID   =   310
   Icon            =   "Admin Console User Accounts Create New.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2565
   ScaleWidth      =   6045
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4245
      TabIndex        =   8
      ToolTipText     =   "Click here to close this window without creating the user account"
      Top             =   1860
      Width           =   1335
   End
   Begin VB.CommandButton cmdHelp 
      Caption         =   "Help"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   2445
      TabIndex        =   7
      ToolTipText     =   "Click here to get additional assistance"
      Top             =   1860
      Width           =   1335
   End
   Begin VB.CommandButton cmdCreate 
      Caption         =   "Create"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   465
      TabIndex        =   6
      ToolTipText     =   "Click here to create the account"
      Top             =   1860
      Width           =   1335
   End
   Begin VB.TextBox txtReEnterPassword 
      Height          =   315
      IMEMode         =   3  'DISABLE
      Left            =   1920
      MaxLength       =   30
      PasswordChar    =   "*"
      TabIndex        =   5
      ToolTipText     =   "Reenter password here. The password entered must match the one entered above."
      Top             =   1260
      Width           =   3795
   End
   Begin VB.TextBox txtPassword 
      Height          =   315
      IMEMode         =   3  'DISABLE
      Left            =   1920
      MaxLength       =   30
      PasswordChar    =   "*"
      TabIndex        =   3
      ToolTipText     =   "Password"
      Top             =   780
      Width           =   3795
   End
   Begin VB.TextBox txtUserName 
      Height          =   315
      Left            =   1920
      MaxLength       =   30
      TabIndex        =   1
      ToolTipText     =   "Enter the username here"
      Top             =   300
      Width           =   3795
   End
   Begin VB.Label Label3 
      Caption         =   "Re-enter Password"
      Height          =   195
      Left            =   300
      TabIndex        =   4
      Top             =   1320
      Width           =   1755
   End
   Begin VB.Label Label2 
      Caption         =   "Password"
      Height          =   195
      Left            =   300
      TabIndex        =   2
      Top             =   840
      Width           =   1755
   End
   Begin VB.Label Label1 
      Caption         =   "User Name"
      Height          =   195
      Left            =   300
      TabIndex        =   0
      Top             =   360
      Width           =   1755
   End
End
Attribute VB_Name = "frmAdminConsole_UserAccounts_CreateNew"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'****************************************************************************
'*                          Create New User Account                         *
'*   -Updates user's table to include a new user                            *
'*   -Initialise rights to 'no access'                                      *
'*   -Checks that name is unique                                            *
'****************************************************************************


Option Explicit

Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub cmdCreate_Click()
    txtUserName.Text = Trim(txtUserName.Text)
    
    If txtUserName.Text = "" Then
        MsgBox "Please enter a user name first.", vbExclamation
        txtUserName.SetFocus
    ElseIf txtPassword.Text = "" Then
        MsgBox "Please enter a password first.", vbExclamation
        txtPassword.SetFocus
    ElseIf txtReEnterPassword.Text = "" Then
        MsgBox "Please reenter the password in the space provided.", vbExclamation
        txtReEnterPassword.SetFocus
    ElseIf txtPassword.Text <> txtReEnterPassword.Text Then
        MsgBox "Entered passwords are different. Please try again.", vbExclamation
        txtPassword.Text = ""
        txtReEnterPassword.Text = ""
        txtPassword.SetFocus
    Else
        'Ensure that name does not alredy exist
        rstUsers.Index = "User Name Index"
        rstUsers.Seek "=", txtUserName.Text
        If rstUsers.NoMatch Then
            rstUsers.AddNew
                rstUsers("User Name") = txtUserName.Text
                rstUsers("User Password") = Encrypt(txtPassword.Text)
                rstUsers("User Rights") = String(30, "0")
            rstUsers.Update
            MsgBox "User account successfull created.", vbInformation
            Unload Me
        Else
            MsgBox "This user name is alredy in use", vbExclamation
            txtUserName.SetFocus
        End If
    End If
            
End Sub

Private Sub cmdHelp_Click()
    ShowHelpTopic 310
End Sub
