Attribute VB_Name = "Encryption"
'Encryption variables
Private Const strStartEndMarker = ""



Public Function Encrypt(strPlainText As String) As String
    Dim lngCharCounter As Long               'Current post in the plain text
    Dim strCharacter As String * 1           'Current Character in plain text
    
    Dim strEncryptionArray() As String       'Array of encryption keys
    Dim strEncryptionCharacter As String * 1 'Character used to create displacement
    
    Dim lngCipherCode As Long                'ASCII code of encrpted character
    Dim strCipherCharacter As String * 1     'Encrypted character after displacement
    Dim strCipherText As String              'The encrypted text
    

    'Obtain array of base values used for displacing the text
    strEncryptionArray = BuildArray
    
    
    For lngCharCounter = 1 To Len(strPlainText)
        strEncryptionCharacter = strEncryptionArray(1 + (lngCharCounter Mod 51))
        strCharacter = Mid(strPlainText, lngCharCounter, 1)
        lngCipherCode = Asc(strEncryptionCharacter) + Asc(strCharacter)
        strCipherCharacter = Chr((lngCipherCode Mod 95) + 32)
        strCipherText = strCipherText & strCipherCharacter
    Next
    
    'Mark start and end of cipher text to avoid loss of values that will be spaces
    Encrypt = strStartEndMarker & strCipherText & strStartEndMarker
    
End Function

Public Function Decrypt(strCipherText As String) As String
    Dim lngCharCounter As Long               'Current pos in the plain text
    Dim strCharacter As String * 1           'Current Character in plain text
    
    Dim strEncryptionArray() As String       'Array of encryption keys
    Dim strEncryptCharacter As String * 1    'Character used to create displacement
    
    Dim lngCipherCode As Long                'ASCII code of encrpted character
    Dim strCipherCharacter As String * 1     'Encrypted character after displacement
    Dim strDecryptCharacter As String * 1    'Decrypted Character
    
    Dim strPlainText As String               'The decrypted text
    
    'Obtain array of base values used for displacing the text
    strEncryptionArray = BuildArray
    
    'Remove start and end markers
    If Len(strCipherText) <= 2 Then
        strCipherText = ""
    Else
        strCipherText = Mid(strCipherText, 2, Len(strCipherText) - 2)
    End If
    
    
    For lngCharCounter = 1 To Len(strCipherText)
        strCipherCharacter = Mid(strCipherText, lngCharCounter, 1)
        strDecryptCharacter = strEncryptionArray(1 + (lngCharCounter Mod 51))
        lngCipherCode = Asc(strCipherCharacter) - 32 - Asc(strDecryptCharacter)
        If lngCipherCode < 0 Then
            lngCipherCode = lngCipherCode + 95
        End If
        
        If lngCipherCode < 32 Then
            lngCipherCode = lngCipherCode + 95
        End If
        
        strPlainText = strPlainText + Chr(lngCipherCode)
    Next
    Decrypt = strPlainText

End Function


Private Function BuildArray() As String()
    
    Dim lngRowCounter As Long
    Dim strEncryptionArray() As String
    Const strSourceText = "MOMMY,DAD,REGINA,RUSSELL,ROSELYN,TINOVIMBA,RUTENDO."
    
    ReDim strEncryptionArray(1 To 51)
    
    For lngRowCounter = 1 To 51
        strEncryptionArray(lngRowCounter) = Mid(strSourceText, lngRowCounter, 1)
    Next
        
    BuildArray = strEncryptionArray
    
End Function

