VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Object = "{86CF1D34-0C5F-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCT2.OCX"
Begin VB.Form frmBalances_FeeClass 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Fee Class Balance Analysis"
   ClientHeight    =   6525
   ClientLeft      =   45
   ClientTop       =   615
   ClientWidth     =   7020
   HelpContextID   =   1110
   Icon            =   "Fee Class Balance Analysis.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   ScaleHeight     =   6525
   ScaleWidth      =   7020
   StartUpPosition =   1  'CenterOwner
   Begin MSComCtl2.DTPicker dtpickStartDate 
      Height          =   315
      Left            =   1920
      TabIndex        =   7
      Top             =   180
      Width           =   3015
      _ExtentX        =   5318
      _ExtentY        =   556
      _Version        =   393216
      Format          =   24444928
      CurrentDate     =   37778
   End
   Begin MSFlexGridLib.MSFlexGrid grdHeader 
      Height          =   1155
      Left            =   120
      TabIndex        =   6
      Top             =   1080
      Width           =   6735
      _ExtentX        =   11880
      _ExtentY        =   2037
      _Version        =   393216
      Rows            =   4
      FixedRows       =   0
      FixedCols       =   0
      BackColor       =   -2147483644
      GridColor       =   0
      AllowUserResizing=   1
   End
   Begin MSFlexGridLib.MSFlexGrid grdClassifiedAmounts 
      Height          =   3555
      Left            =   120
      TabIndex        =   5
      Top             =   2220
      Width           =   6735
      _ExtentX        =   11880
      _ExtentY        =   6271
      _Version        =   393216
      Cols            =   3
      AllowUserResizing=   1
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4560
      TabIndex        =   2
      Top             =   6000
      Width           =   1395
   End
   Begin VB.CommandButton cmdHelp 
      Caption         =   "Help"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   2580
      TabIndex        =   1
      Top             =   6000
      Width           =   1395
   End
   Begin VB.CommandButton cmdAnalyse 
      Caption         =   "Analyse"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   480
      TabIndex        =   0
      Top             =   6000
      Width           =   1395
   End
   Begin MSComDlg.CommonDialog cdlgBalanceAnalysis 
      Left            =   5460
      Top             =   360
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin MSComCtl2.DTPicker dtpickEndDate 
      Height          =   315
      Left            =   1920
      TabIndex        =   8
      Top             =   600
      Width           =   3015
      _ExtentX        =   5318
      _ExtentY        =   556
      _Version        =   393216
      Format          =   24444928
      CurrentDate     =   37778
   End
   Begin VB.Label Label3 
      Caption         =   "Start Date"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   840
      TabIndex        =   4
      Top             =   240
      Width           =   975
   End
   Begin VB.Label Label2 
      Caption         =   "End Date"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   840
      TabIndex        =   3
      Top             =   660
      Width           =   975
   End
   Begin VB.Menu mnuTools 
      Caption         =   "Tools"
      Begin VB.Menu mnuTools_ExportToExcel 
         Caption         =   "Export To Excel"
      End
      Begin VB.Menu mnuTools_ExportToGenericFormat 
         Caption         =   "Export To Generic Format"
      End
      Begin VB.Menu mnuTools_Sep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuTools_Print 
         Caption         =   "Print"
      End
      Begin VB.Menu mnuTools_Sep2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuTools_Help 
         Caption         =   "Help"
      End
      Begin VB.Menu mnuTools_Sep3 
         Caption         =   "-"
      End
      Begin VB.Menu mnuTools_Close 
         Caption         =   "Close"
      End
   End
End
Attribute VB_Name = "frmBalances_FeeClass"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Fee Class Balance Analysis
'Returns the total fees charged under a given fee over a user defined period

Option Explicit

Private Loading As Boolean

Private Sub InitialiseGrids()
    
    grdClassifiedAmounts.Clear
    grdClassifiedAmounts.Rows = 2
    
    grdClassifiedAmounts.ColWidth(0) = 465
    grdClassifiedAmounts.ColAlignment(0) = flexAlignRightCenter
    
    Call EnterGridData(grdClassifiedAmounts, 0, 1, "Details")
    grdClassifiedAmounts.ColWidth(1) = 4065
    grdClassifiedAmounts.ColAlignment(1) = flexAlignLeftCenter
    grdClassifiedAmounts.FixedAlignment(1) = flexAlignLeftCenter
    
    Call EnterGridData(grdClassifiedAmounts, 0, 2, "Amount")
    grdClassifiedAmounts.ColWidth(2) = 1815
    grdClassifiedAmounts.ColAlignment(2) = flexAlignRightCenter
    grdClassifiedAmounts.FixedAlignment(2) = flexAlignCenterCenter
    
    grdHeader.Clear
    grdHeader.ColWidth(0) = 1845
    grdHeader.ColWidth(1) = 4290
    
End Sub
Private Sub cmdAnalyse_Click()
    DoAnalysis
End Sub

Private Sub DoAnalysis()
    Dim dtmStartDate As Date
    Dim dtmEndDate As Date
        
    dtmStartDate = dtpickStartDate.Value
    dtmEndDate = dtpickEndDate.Value
    
    If Not (EndDateBeforeStartDate(dtmStartDate, dtmEndDate) _
            Or DateInTheFuture(dtmEndDate, "End Date")) Then
        
        InitialiseGrids
        Screen.MousePointer = vbHourglass
        Call EnterHeaderInformation(dtmStartDate, dtmEndDate)
        Call EnterDepositsAnalysis(dtmStartDate, dtmEndDate)
        Call EnterTotalLevyPayments(dtmStartDate, dtmEndDate)
        Call EnterLevyFeesCharged(dtmStartDate, dtmEndDate)
        Screen.MousePointer = vbDefault
    End If
    
End Sub

Private Sub EnterHeaderInformation(dtmStartDate As Date, dtmEndDate As Date)
    
    Call EnterGridData(grdHeader, 0, 0, "Title")
    Call EnterGridData(grdHeader, 0, 1, "Fee Class Balance Analysis")
    
    Call EnterGridData(grdHeader, 1, 0, "Start Date")
    Call EnterGridData(grdHeader, 1, 1, Format(dtmStartDate, "dddd d mmmm yyyy"))
    
    Call EnterGridData(grdHeader, 2, 0, "End Date")
    Call EnterGridData(grdHeader, 2, 1, Format(dtmEndDate, "dddd d mmmm yyyy"))
    
    Call EnterGridData(grdHeader, 3, 0, "Created")
    Call EnterGridData(grdHeader, 3, 1, Format(Now, "dddd d mmmm yyyy hh:mm") & " hrs")
    
        
End Sub

Private Sub EnterDepositsAnalysis(dtmStartDate As Date, dtmEndDate As Date)
    
    Dim lngOffSet As Long
    Dim lngCounter As Long
    Dim rstDepositAnalysis As Recordset
    
    Set rstDepositAnalysis = AnalyseDepositBalances(dtmStartDate, dtmEndDate)
    rstDepositAnalysis.MoveLast
    rstDepositAnalysis.MoveFirst
    
    lngOffSet = grdClassifiedAmounts.Rows
    grdClassifiedAmounts.Rows = lngOffSet + rstDepositAnalysis.RecordCount + 2
    
    Call EnterGridData(grdClassifiedAmounts, lngOffSet, 1, "Deposit Analysis")
    Call SetGridBoldText(grdClassifiedAmounts, lngOffSet, 1)
    
    'Enter Body
        
    For lngCounter = (1 + lngOffSet) To (rstDepositAnalysis.RecordCount + lngOffSet)
        Call EnterGridData(grdClassifiedAmounts, lngCounter, 1, _
                           rstDepositAnalysis("Description"))
        Call EnterGridData(grdClassifiedAmounts, lngCounter, 2, _
                           CurrencyFormat(rstDepositAnalysis("Amount"), moneyOmitSign, moneyExcludeType))
        rstDepositAnalysis.MoveNext
    Next

    
    
End Sub

Private Sub EnterTotalLevyPayments(dtmStartDate As Date, dtmEndDate As Date)
    Dim lngOffSet As Long
    
    lngOffSet = grdClassifiedAmounts.Rows
    grdClassifiedAmounts.Rows = lngOffSet + 5
    
    Call EnterGridData(grdClassifiedAmounts, lngOffSet, 1, "Levy Payments")
    Call SetGridBoldText(grdClassifiedAmounts, lngOffSet, 1)
    
    Call EnterGridData(grdClassifiedAmounts, 1 + lngOffSet, 1, "Total : " & _
                       FormatDateTime(dtmStartDate, vbShortDate) & " - " & _
                       FormatDateTime(dtmEndDate, vbShortDate))
    Call EnterGridData(grdClassifiedAmounts, 1 + lngOffSet, 2, _
                       CurrencyFormat(getTotalLevyPayments(dtmStartDate, dtmEndDate), _
                       moneyOmitSign, moneyExcludeType))
    
    Call EnterGridData(grdClassifiedAmounts, 2 + lngOffSet, 1, "Current Accrual ")
    Call EnterGridData(grdClassifiedAmounts, 2 + lngOffSet, 2, _
                       CurrencyFormat(getAccruedLevyPayments, moneyOmitSign, moneyExcludeType))
    
    Call EnterGridData(grdClassifiedAmounts, 3 + lngOffSet, 1, "Current Prepayments")
    Call EnterGridData(grdClassifiedAmounts, 3 + lngOffSet, 2, _
                       CurrencyFormat(getPrepaidLevyPayments, moneyOmitSign, moneyExcludeType))
    
    
End Sub

Private Sub EnterLevyFeesCharged(dtmStartDate As Date, dtmEndDate As Date)
    Dim lngCounter As Long
    Dim lngOffSet As Long
    Dim rstBalanceAnalysis As Recordset
    
    
    'Populate recordset
    Set rstBalanceAnalysis = getLevyFeesChargedTotals(dtmStartDate, dtmEndDate)
    rstBalanceAnalysis.MoveLast
    rstBalanceAnalysis.MoveFirst
    
    'Set Start Address of next write and increase rows in grid accordingly
    lngOffSet = grdClassifiedAmounts.Rows
    grdClassifiedAmounts.Rows = lngOffSet + rstBalanceAnalysis.RecordCount + 3
        
    'Enter Header
    Call EnterGridData(grdClassifiedAmounts, lngOffSet, 1, "Levy Fees Charged: " & _
                       FormatDateTime(dtmStartDate, vbShortDate) & " - " & _
                       FormatDateTime(dtmEndDate, vbShortDate))
    Call SetGridBoldText(grdClassifiedAmounts, lngOffSet, 1)
    
    'Enter Body
    If rstBalanceAnalysis.RecordCount = 0 Then
        Call EnterGridData(grdClassifiedAmounts, 1 + lngOffSet, 1, "(None)")
    Else
        rstBalanceAnalysis.MoveLast
        rstBalanceAnalysis.MoveFirst
        
        For lngCounter = (1 + lngOffSet) To (rstBalanceAnalysis.RecordCount + lngOffSet)
            Call EnterGridData(grdClassifiedAmounts, lngCounter, 1, _
                               rstBalanceAnalysis("Description"))
            Call EnterGridData(grdClassifiedAmounts, lngCounter, 2, _
                               CurrencyFormat(rstBalanceAnalysis("Amount"), moneyOmitSign, moneyExcludeType))
            rstBalanceAnalysis.MoveNext
        Next
    End If
    


End Sub
    

Private Function getLevyFeesChargedTotals(dtmStartDate, dtmEndDate) As Recordset
    Dim strSQL As String
    
    strSQL = "SELECT      Description, " _
          & "            IIF(IsNull(Total), 0, Total) As Amount " _
          & "FROM " _
          & "( " _
          & "    SELECT DISTINCTROW " _
          & "            [Registered Fees].[Fee Name] AS [Description], " _
          & "            (  SELECT SUM([Levy Account Debits].[Amount]) " _
          & "               FROM [Levy Account Debits] " _
          & "               WHERE ([Levy Account Debits].[Transaction date] >= [Start Date]) " _
          & "               AND (DateValue( [Levy Account Debits].[Transaction Date])  <= DateValue([End Date])) " _
          & "               AND  [Levy Account Debits].[Fee Code] = [Registered Fees].[Fee Code] " _
          & "             )AS Total " _
          & "    FROM [Registered Fees] " _
          & "    LEFT JOIN [Levy Account Debits] " _
          & "    ON [Registered Fees].[Fee Code] = [Levy Account Debits].[Fee Code] " _
          & ")"
          
    
    qryQueryObject.SQL = strSQL
    qryQueryObject.Parameters("Start date") = dtmStartDate
    qryQueryObject.Parameters("End Date") = dtmEndDate
    Set getLevyFeesChargedTotals = qryQueryObject.OpenRecordset
    
End Function

Private Function getTotalLevyPayments(dtmStartDate As Date, dtmEndDate As Date) As Currency
    Dim rstTotalPayments As Recordset
    Dim strSQL As String
    
    strSQL = "SELECT  IIF(IsNull(Total), 0, Total) As Amount " _
          & "FROM " _
          & "( " _
          & "    SELECT  SUM([Levy Account Credits].[Amount])  AS Total " _
          & "    FROM    [Levy Account Credits] " _
          & "    WHERE   ([Levy Account Credits].[Transaction date] >= [Start Date]) " _
          & "            AND (DateValue( [Levy Account Credits].[Transaction Date])  <= DateValue([End Date])) " _
          & ");"
                        
    qryQueryObject.SQL = strSQL
    qryQueryObject.Parameters("Start date") = dtmStartDate
    qryQueryObject.Parameters("End Date") = dtmEndDate
    Set rstTotalPayments = qryQueryObject.OpenRecordset
    
    rstTotalPayments.MoveFirst
    getTotalLevyPayments = rstTotalPayments("Amount")
    
End Function

Private Function getAccruedLevyPayments() As Currency
    Dim strSQL As String
    Dim rstAccrual As Recordset
    
    strSQL = "SELECT DISTINCTROW   SUM([Balance]) as [Accrual]" _
          & "FROM " _
          & "(   SELECT [Student ID], " _
          & "       IIF (isNull([Unrevised Debits]),0,[Unrevised Debits]) AS [Total Debits], " _
          & "       IIF (isNull([Unrevised Credits]),0,[Unrevised Credits]) AS  [Total Credits], " _
          & "       ([Total Credits] - [Total Debits]) AS Balance " _
          & "    FROM  " _
          & "    ( " _
          & "       SELECT DISTINCTROW " _
          & "           [Students].[Student ID] AS [Student ID], " _
          & "           [Students].[Surname] AS [Surname], " _
          & "           [Students].[First Names] AS [First Names], " _
          & "           [Students].[Class] AS [Class], " _
          & "           (   SELECT     Sum([Levy Account Credits].[Amount]) " _
          & "               FROM       [Levy Account Credits] " _
          & "               WHERE [Levy Account Credits].[Student ID] = [Students].[Student ID] " _
          & "           )   AS [Unrevised Credits], " _
          & "           (   SELECT     Sum([Levy Account Debits].[Amount]) " _
          & "               FROM [Levy Account Debits] " _
          & "               WHERE [Levy Account Debits].[Student ID] = [Students].[Student ID] " _
          & "           ) AS [Unrevised Debits] " _
          & "       FROM   [Students], [Levy Account Debits], [Levy Account Credits] " _
          & "    )) " _
          & "    WHERE [Balance] < 0" _
          & " "
    
    qryQueryObject.SQL = strSQL
    Set rstAccrual = qryQueryObject.OpenRecordset
    getAccruedLevyPayments = rstAccrual("Accrual")
    
End Function

Private Function getPrepaidLevyPayments() As Currency
    
    Dim strSQL As String
    Dim rstPrepayment As Recordset
    
    strSQL = "SELECT DISTINCTROW   SUM([Balance]) as [Prepayment]" _
          & "FROM " _
          & "(   SELECT [Student ID], " _
          & "       IIF (isNull([Unrevised Debits]),0,[Unrevised Debits]) AS [Total Debits], " _
          & "       IIF (isNull([Unrevised Credits]),0,[Unrevised Credits]) AS  [Total Credits], " _
          & "       ([Total Credits] - [Total Debits]) AS Balance " _
          & "    FROM  " _
          & "    ( " _
          & "       SELECT DISTINCTROW " _
          & "           [Students].[Student ID] AS [Student ID], " _
          & "           [Students].[Surname] AS [Surname], " _
          & "           [Students].[First Names] AS [First Names], " _
          & "           [Students].[Class] AS [Class], " _
          & "           (   SELECT     Sum([Levy Account Credits].[Amount]) " _
          & "               FROM       [Levy Account Credits] " _
          & "               WHERE [Levy Account Credits].[Student ID] = [Students].[Student ID] " _
          & "           )   AS [Unrevised Credits], " _
          & "           (   SELECT     Sum([Levy Account Debits].[Amount]) " _
          & "               FROM [Levy Account Debits] " _
          & "               WHERE [Levy Account Debits].[Student ID] = [Students].[Student ID] " _
          & "           ) AS [Unrevised Debits] " _
          & "       FROM   [Students], [Levy Account Debits], [Levy Account Credits] " _
          & ")    ) " _
          & "    WHERE [Balance] > 0" _
          & " "
    
    qryQueryObject.SQL = strSQL
    Set rstPrepayment = qryQueryObject.OpenRecordset
    getPrepaidLevyPayments = rstPrepayment("Prepayment")
    
End Function


Private Sub cmdClose_Click()
    Unload Me
End Sub

Private Sub cmdHelp_Click()
    ShowHelpTopic 1110
End Sub

Private Sub Form_Activate()
    Dim lngCounter As Long
    
    If CurrentUser.Allowed_Balances_FeeClass Then
        If Loading Then
            Loading = False
            
            InitialiseGrids
            
            'Specify default selections
            dtpickStartDate.Value = DateSerial(Year(Date), 1, 1)
            
            dtpickEndDate.Value = Date
        End If
    Else
        GiveSecViolationMsg ("perform fee class balance analysis")
        Unload Me
    End If
        
End Sub

Private Sub Form_Load()
    Loading = True
End Sub

Private Sub Form_Unload(Cancel As Integer)
    frmSystem_MainMenu.SetFocus
End Sub

Private Sub mnuTools_Close_Click()
    cmdClose.Value = True
End Sub

Private Function HeaderEmpty() As Boolean
    
    If Trim(GetGridData(grdHeader, 0, 0)) = "" Then
        HeaderEmpty = True
    Else
        HeaderEmpty = False
    End If
    
End Function

Private Sub mnuTools_ExportToExcel_Click()
    
    If Not HeaderEmpty Then
        ReformatAmounts
        ExportGridToExcel Me, grdClassifiedAmounts, grdHeader
        DoAnalysis
    End If
    
End Sub

Private Sub ReformatAmounts()
    Dim lngRowCounter As Long
    
    grdClassifiedAmounts.Col = 2
    For lngRowCounter = 1 To grdClassifiedAmounts.Rows - 1
        grdClassifiedAmounts.Row = lngRowCounter
        If Trim(grdClassifiedAmounts.Text) <> "" Then
            grdClassifiedAmounts.Text = Trim(Str(Val(Trim(grdClassifiedAmounts.Text))))
        End If
    Next
    
End Sub

Private Sub mnuTools_Help_Click()
    cmdHelp.Value = True
End Sub

Private Sub mnuTools_Print_Click()
    On Local Error GoTo errorHandler
    Dim lngRowCounter As Long
    Dim lngColCounter As Long
    
    If Not (HeaderEmpty) Then
        'Get details of target printer
        With Me.cdlgBalanceAnalysis
            .PrinterDefault = True
            .CancelError = True
            .Flags = cdlPDHidePrintToFile
            .ShowPrinter
        End With
        Printer.Font.Name = "Courier New"
        Printer.Font.Size = 12
        
        'Initialise printer
        Printer.ScaleMode = vbCharacters
        Printer.CurrentY = 3
        
        'Start by printing header
        For lngRowCounter = 0 To grdHeader.Rows - 1
            Printer.CurrentX = 3
            Printer.Print GetGridData(grdHeader, lngRowCounter, 0);
            
            Printer.CurrentX = 22
            Printer.Print GetGridData(grdHeader, lngRowCounter, 1)
        Next
        PrintBlankLines (2)
        
        'Send Body Header
        Printer.CurrentX = 3
        Printer.Print "Description";
        
        Printer.CurrentX = 50
        Printer.Print "Amount"
        PrintBlankLines (1)
        Printer.Line (0, Printer.CurrentY)-(Printer.ScaleWidth, Printer.CurrentY)
        PrintBlankLines (1)
        
        
        'Send Body
        For lngRowCounter = 1 To grdClassifiedAmounts.Rows - 1
            Printer.CurrentX = 3
            Printer.Print GetGridData(grdClassifiedAmounts, lngRowCounter, 1);
            
            If GetGridData(grdClassifiedAmounts, lngRowCounter, 2) <> "" Then
                Printer.CurrentX = 43
                Printer.Print CurrencyFormat(Val(GetGridData(grdClassifiedAmounts, lngRowCounter, 2)), , moneyExcludeType)
            Else
                'Nothing printed - Reposition to next line
                Printer.CurrentY = Printer.CurrentY + 1
            End If
        Next
        Printer.EndDoc
    End If
        
Exit Sub

errorHandler:
    If Err.Number <> cdlCancel Then
        MsgBox Err.Description, vbExclamation, "Printing Error"
    End If

End Sub

Private Function AnalyseDepositBalances(dtmStartDate As Date, dtmEndDate As Date) As Recordset
    Dim strSQL As String
    
    'Execute a query to analyse the balances. Each section returns only one record
    strSQL = getDurationDebits_DepositAnalysisSection _
           & getDurationCredits_DepositAnalysisSection _
           & getCurrentDebits_DepositAnalysisSection _
           & getCurrentCredits_DepositAnalysisSection _
           & getCurrentShortfalls_DepositAnalysisSection _
           & getCurrentExcesses_DepositAnalysisSection _
           & getCurrentNetPosition_DepositAnalysisSection _
           & getCurrentTotalMinBals_DepositAnalysisSection
    
    qryQueryObject.SQL = strSQL
    qryQueryObject.Parameters("Start Date") = dtmStartDate
    qryQueryObject.Parameters("End Date") = dtmEndDate
    Set AnalyseDepositBalances = qryQueryObject.OpenRecordset
    
End Function

Private Sub mnuTools_ExportToGenericFormat_Click()
    If Not HeaderEmpty Then
        ReformatAmounts
        ExportGridToGeneric Me, grdClassifiedAmounts, grdHeader
        DoAnalysis
    End If
End Sub
