Attribute VB_Name = "GridFormating"
Public Sub EnterGridData(targetGrid As MSFlexGrid, tgtRow As Long, tgtCol As Long, Txt As String)
    
    targetGrid.Col = tgtCol
    targetGrid.Row = tgtRow
    targetGrid.Text = Txt
    
End Sub

Public Function GetGridData(targetGrid As MSFlexGrid, tgtRow As Long, tgtCol As Long) As String
    
    targetGrid.Col = tgtCol
    targetGrid.Row = tgtRow
    GetGridData = Trim(targetGrid.Text)
    
End Function

Public Sub BlankOutGrid(targetGrid As MSFlexGrid)
    Dim rowCounter As Long
    Dim colCounter As Long
    
    For rowCounter = 0 To targetGrid.Rows - 1
        For colCounter = 1 To targetGrid.Cols - 1
            Call EnterGridData(targetGrid, rowCounter, colCounter, "")
        Next
    Next
            
End Sub

Public Sub SetGridForeColor(tgtGrid As MSFlexGrid, tgtRow As Long, tgtCol As Long, tgtColor As Long)
    
    tgtGrid.Col = tgtCol
    tgtGrid.Row = tgtRow
    tgtGrid.CellForeColor = tgtColor
    
End Sub

Public Sub SetGridBoldText(tgtGrid As MSFlexGrid, tgtRow As Long, tgtCol As Long)
    
    tgtGrid.Col = tgtCol
    tgtGrid.Row = tgtRow
    tgtGrid.CellFontBold = True
    
End Sub


Public Sub CopyGrid(Consumer As MSFlexGrid, Supplier As MSFlexGrid)
    Dim rowCounter As Long
    Dim colCounter As Long
    
    
    For colCounter = 0 To Supplier.Cols - 1
        Supplier.Col = colCounter
        Consumer.Col = colCounter
        'Copy alignment and column width
        Consumer.ColWidth(colCounter) = Supplier.ColWidth(colCounter)
        Consumer.ColAlignment(colCounter) = Supplier.ColAlignment(colCounter)
        For rowCounter = 0 To Supplier.Rows - 1
            Supplier.Row = rowCounter
            Consumer.Row = rowCounter
            'Copy Text and cell coloring
            Consumer.Text = Supplier.Text
            Consumer.CellForeColor = Supplier.CellForeColor
        Next
    Next
            
End Sub

