VERSION 5.00
Begin VB.Form frmLevy_Charge_InsertFee 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Charge Levies: Insert Fee"
   ClientHeight    =   2010
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4560
   HelpContextID   =   890
   Icon            =   "Insert Fee Into Charge Form.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2010
   ScaleWidth      =   4560
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.TextBox txtDollars 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   1740
      MaxLength       =   7
      TabIndex        =   1
      Top             =   660
      Width           =   1695
   End
   Begin VB.TextBox txtCents 
      Height          =   285
      Left            =   3420
      MaxLength       =   2
      TabIndex        =   2
      Top             =   660
      Width           =   735
   End
   Begin VB.ComboBox cboFeeName 
      Height          =   315
      Left            =   1620
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   120
      Width           =   2535
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   435
      Left            =   3240
      TabIndex        =   5
      Top             =   1320
      Width           =   1095
   End
   Begin VB.CommandButton cmdHelp 
      Caption         =   "Help"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   435
      Left            =   1680
      TabIndex        =   4
      Top             =   1320
      Width           =   1095
   End
   Begin VB.CommandButton cmdInsertFee 
      Caption         =   "Insert Fee"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   435
      Left            =   120
      TabIndex        =   3
      Top             =   1320
      Width           =   1095
   End
   Begin VB.Label Label4 
      Caption         =   "$"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   1560
      TabIndex        =   8
      Top             =   720
      Width           =   135
   End
   Begin VB.Label Label2 
      Caption         =   "Amount"
      Height          =   255
      Left            =   240
      TabIndex        =   7
      Top             =   660
      Width           =   1575
   End
   Begin VB.Label Label1 
      Caption         =   "Fee Name"
      Height          =   255
      Left            =   240
      TabIndex        =   6
      Top             =   180
      Width           =   1575
   End
End
Attribute VB_Name = "frmLevy_Charge_InsertFee"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Loading As Boolean

Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub cmdHelp_Click()
    ShowHelpTopic 890
End Sub

Private Sub cmdInsertFee_Click()
    
    If cboFeeName.ListIndex = -1 Then
        MsgBox "Please select a fee first", vbExclamation, "Insert Fee"
    ElseIf txtDollars.Text = "" Then
        MsgBox "Please enter the dollars part of the fee amount", vbExclamation, "Insert Fee"
    ElseIf txtCents.Text = "" Then
        MsgBox "Please enter the cents part of the fee amount", vbExclamation, "Insert Fee"
    Else
        'Locate insertion Point into grid
        frmLevy_Charge.grdCharges.Col = 0
        frmLevy_Charge.grdCharges.Row = 1
        While Trim(frmLevy_Charge.grdCharges.Text) <> ""
            frmLevy_Charge.grdCharges.Row = frmLevy_Charge.grdCharges.Row + 1
        Wend
        
        'Place fee name into grid
        frmLevy_Charge.grdCharges.Text = cboFeeName.List(cboFeeName.ListIndex)
        
        'Place fee amount into grid
        frmLevy_Charge.grdCharges.Col = 1
        frmLevy_Charge.grdCharges.Text = txtDollars.Text & "." & txtCents.Text
        
        'Return Control to parent form
        Unload Me
    End If
    
End Sub

Private Sub Form_Activate()
    'Load all the available fee into the combo box
    If Loading Then
        Loading = False
        rstRegisteredFees.Index = "Fee Name Index"
        rstRegisteredFees.MoveFirst
        Do
            cboFeeName.AddItem rstRegisteredFees("Fee Name")
            rstRegisteredFees.MoveNext
        Loop Until rstRegisteredFees.EOF
            
    End If
        
End Sub

Private Sub Form_Load()
    Loading = True
End Sub

Private Sub txtDollars_KeyPress(KeyAscii As Integer)
    
    If (KeyAscii < Asc("0") Or KeyAscii > Asc("9")) And KeyAscii <> 8 Then
        
        'Cancel key stroke
        Beep
        KeyAscii = 0
    End If

End Sub

Private Sub txtCents_KeyPress(KeyAscii As Integer)
    
    If (KeyAscii < Asc("0") Or KeyAscii > Asc("9")) And KeyAscii <> 8 Then
        
        'Cancel key stroke
        Beep
        KeyAscii = 0
    End If

End Sub

