VERSION 5.00
Object = "{86CF1D34-0C5F-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCT2.OCX"
Begin VB.Form frmLevy_Statement_Individual_Load 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Load Levy Statement"
   ClientHeight    =   2130
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4725
   HelpContextID   =   910
   Icon            =   "Load Individual Statement.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2130
   ScaleWidth      =   4725
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin MSComCtl2.DTPicker dtpickEndDate 
      Height          =   315
      Left            =   1320
      TabIndex        =   8
      Top             =   1020
      Width           =   3195
      _ExtentX        =   5636
      _ExtentY        =   556
      _Version        =   393216
      Format          =   24444928
      CurrentDate     =   37777
   End
   Begin MSComCtl2.DTPicker dtpickStartDate 
      Height          =   315
      Left            =   1320
      TabIndex        =   7
      Top             =   600
      Width           =   3195
      _ExtentX        =   5636
      _ExtentY        =   556
      _Version        =   393216
      Format          =   24444928
      CurrentDate     =   37777
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   3300
      TabIndex        =   6
      Top             =   1620
      Width           =   1095
   End
   Begin VB.CommandButton cmdHelp 
      Caption         =   "Help"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1800
      TabIndex        =   5
      Top             =   1620
      Width           =   1095
   End
   Begin VB.CommandButton cmdLoad 
      Caption         =   "Load"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   240
      TabIndex        =   4
      Top             =   1620
      Width           =   1095
   End
   Begin VB.TextBox txtStudentID 
      Height          =   315
      Left            =   1320
      TabIndex        =   1
      Top             =   180
      Width           =   3195
   End
   Begin VB.Label Label3 
      Caption         =   "Start Date"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   180
      TabIndex        =   3
      Top             =   660
      Width           =   975
   End
   Begin VB.Label Label2 
      Caption         =   "End Date"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   180
      TabIndex        =   2
      Top             =   1080
      Width           =   975
   End
   Begin VB.Label Label1 
      Caption         =   "Student ID"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   180
      TabIndex        =   0
      Top             =   240
      Width           =   975
   End
End
Attribute VB_Name = "frmLevy_Statement_Individual_Load"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Loading As Boolean


Private Sub cmdCancel_Click()
    Unload Me
End Sub


Private Sub cmdHelp_Click()
    ShowHelpTopic 910
End Sub

Private Sub cmdLoad_Click()
    
    Dim strStudentID As String
    Dim dtmStartDate As Date
    Dim dtmEndDate As Date
    
    strStudentID = txtStudentID.Text
    dtmStartDate = dtpickStartDate.Value
    dtmEndDate = dtpickEndDate.Value
    
    If txtStudentID.Text = "" Then
        MsgBox "Please enter the Student ID", vbExclamation, "Load Statement"
    ElseIf Not (EndDateBeforeStartDate(dtmStartDate, dtmEndDate) _
               Or InvalidStudentID(strStudentID) _
               Or DateInTheFuture(dtmEndDate, "End Date")) Then
        Call EnterStudentDetails(dtmStartDate, dtmEndDate)
        Call EnterOpeningBalance(strStudentID, dtmStartDate)
        
        Call EnterStatementBody(strStudentID, dtmStartDate, dtmEndDate)
        Call EnterClosingBalance(strStudentID, dtmEndDate)
        Call InsertRowNumbers
        Unload Me
    End If
        
End Sub

Private Sub EnterStudentDetails(ByVal dtmStartDate As Date, ByVal dtmEndDate As Date)
    
    Dim Hostform As Form
    Set Hostform = frmLevy_Statement_Individual_Display
       
    Hostform.lblStudentID.Caption = rstStudents("Student ID")
    Hostform.lblName.Caption = rstStudents("Surname") & " " & rstStudents("First Names")
    Hostform.lblClass.Caption = rstStudents("Class")
    Hostform.lblPeriod.Caption = Format(dtmStartDate, "d mmmm yyyy") & " - "
    Hostform.lblPeriod.Caption = Hostform.lblPeriod.Caption & Format(dtmEndDate, "d mmmm yyyy")
    
    
End Sub

Private Sub EnterOpeningBalance(strStudentID As String, dtmStartDate As Date)
    
    Dim HostGrid As MSFlexGrid
    Dim curOpeningBalance As Currency
    
    Set HostGrid = frmLevy_Statement_Individual_Display.grdStatementOfAccount
    
    HostGrid.Row = 1
    
    HostGrid.Col = 1
    HostGrid.Text = Format(dtmStartDate, "dd mmm yyyy")
    
    HostGrid.Col = 2
    HostGrid.Text = "Opening Balance"
    
    HostGrid.Col = 3
    curOpeningBalance = GetLevyOpeningBalance(strStudentID, dtmStartDate)
    HostGrid.Text = CurrencyFormat(curOpeningBalance, moneyOmitSign, moneyExcludeType)
    
    'color red if debit. Blue otherwise
    If curOpeningBalance < 0 Then
        HostGrid.CellForeColor = vbRed
    Else
        HostGrid.CellForeColor = vbBlue
    End If
    
End Sub

Private Sub EnterStatementBody(strStudentID As String, ByVal dtmStartDate As Date, ByVal dtmEndDate As Date)
    
    Dim rstStatementOfAccount As Recordset
    Dim HostGrid As MSFlexGrid
    Dim Amount As Currency
    Dim lngRowCounter As Long
    
    'Generate Statement of account excluding balances
    qryQueryObject.SQL = GetLevyStatementBodySQL()
    qryQueryObject.Parameters("The Student") = strStudentID
    qryQueryObject.Parameters("Start Date") = dtmStartDate
    qryQueryObject.Parameters("End date") = dtmEndDate
    Set rstStatementOfAccount = qryQueryObject.OpenRecordset
    
    Set HostGrid = frmLevy_Statement_Individual_Display.grdStatementOfAccount
    
    HostGrid.Rows = 3 + rstStatementOfAccount.RecordCount
    If rstStatementOfAccount.RecordCount > 0 Then
        rstStatementOfAccount.MoveFirst
        For lngRowCounter = 2 To rstStatementOfAccount.RecordCount + 1
            HostGrid.Row = lngRowCounter
            
            HostGrid.Col = 1
            HostGrid.Text = Format(rstStatementOfAccount("Transaction Date"), "dd mmm yyyy")
            
            HostGrid.Col = 2
            HostGrid.Text = rstStatementOfAccount("Description")
            
            HostGrid.Col = 3
            Amount = rstStatementOfAccount("Amount")
            HostGrid.Text = CurrencyFormat(Amount, moneyOmitSign, moneyExcludeType)
            If Amount < 0 Then
                HostGrid.CellForeColor = vbRed
            Else
                HostGrid.CellForeColor = vbBlue
            End If
            
            rstStatementOfAccount.MoveNext
            
        Next
    End If
            
End Sub

Private Sub EnterClosingBalance(strStudentID As String, ByVal dtmEndDate As Date)
    
    Dim HostGrid As MSFlexGrid
    Dim curClosingBalance As Currency
    Set HostGrid = frmLevy_Statement_Individual_Display.grdStatementOfAccount
    
    HostGrid.Row = HostGrid.Rows - 1
    
    HostGrid.Col = 1
    HostGrid.Text = Format(dtmEndDate, "dd mmm yyyy")
    
    HostGrid.Col = 2
    HostGrid.Text = "Closing Balance"
    
    HostGrid.Col = 3
    curClosingBalance = GetLevyClosingBalance(strStudentID, dtmEndDate)
    HostGrid.Text = CurrencyFormat(curClosingBalance, moneyOmitSign, moneyExcludeType)
    
    If curClosingBalance < 0 Then
        HostGrid.CellForeColor = vbRed
    Else
        HostGrid.CellForeColor = vbBlue
    End If
    
    
    If curClosingBalance <= 0 Then
        frmLevy_Statement_Individual_Display.lblBalanceDescription.Caption = "Balance Owing  "
    Else
        frmLevy_Statement_Individual_Display.lblBalanceDescription.Caption = "Levies Prepaid"
    End If
    
    frmLevy_Statement_Individual_Display.lblBalanceAmount.Caption = CurrencyFormat(curClosingBalance)
    
End Sub

Private Sub InsertRowNumbers()
    Dim lngRowCounter As Long
    Dim HostGrid As MSFlexGrid
    
    Set HostGrid = frmLevy_Statement_Individual_Display.grdStatementOfAccount
    
    HostGrid.Col = 0
    For lngRowCounter = 1 To HostGrid.Rows - 1
        HostGrid.Row = lngRowCounter
        HostGrid.Text = Str(lngRowCounter) & " "
    Next
End Sub

Private Sub Form_Load()
    Loading = True
End Sub

Private Sub Form_Activate()
    
    If Loading Then
        Loading = False
        
        If CurrentUser.Allowed_LevyAc_IndividualStmt Then
            'Set Start date to 1 January  of current year
            dtpickStartDate.Value = DateSerial(Year(Now), 1, 1)
            
            'Set End Date to today's date
            dtpickEndDate = Date
            
            'Default student ID is that of currently displayed statement if any
            txtStudentID.Text = frmLevy_Statement_Individual_Display.lblStudentID.Caption
            txtStudentID.SetFocus
        Else
            GiveSecViolationMsg "generate individual levy fees statments of account"
            Unload Me
        End If
    End If
            
    
End Sub

