VERSION 5.00
Begin VB.Form frmSearch_Master 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Search"
   ClientHeight    =   1950
   ClientLeft      =   150
   ClientTop       =   150
   ClientWidth     =   4800
   HelpContextID   =   710
   Icon            =   "Search.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1950
   ScaleWidth      =   4800
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.TextBox txtSearchString 
      Height          =   315
      Left            =   1500
      TabIndex        =   1
      Top             =   660
      Width           =   2655
   End
   Begin VB.ComboBox cboSearchItem 
      Height          =   315
      ItemData        =   "Search.frx":030A
      Left            =   1500
      List            =   "Search.frx":031D
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   180
      Width           =   2655
   End
   Begin VB.CommandButton cmdHelp 
      Caption         =   "Help"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1620
      TabIndex        =   3
      Top             =   1260
      Width           =   1215
   End
   Begin VB.CommandButton cmdClose 
      Cancel          =   -1  'True
      Caption         =   "Close"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   3060
      TabIndex        =   4
      Top             =   1260
      Width           =   1215
   End
   Begin VB.CommandButton cmdSearch 
      Caption         =   "Search"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   240
      TabIndex        =   2
      Top             =   1260
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Search String"
      Height          =   195
      Left            =   180
      TabIndex        =   6
      Top             =   720
      Width           =   1335
   End
   Begin VB.Label Label4 
      Caption         =   "Search Item"
      Height          =   195
      Left            =   180
      TabIndex        =   5
      Top             =   240
      Width           =   1335
   End
End
Attribute VB_Name = "frmSearch_Master"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Searches the students table
'Supports pattern matching
'Also handles searching requests from other forms

Option Explicit
Private Loading As Boolean

Private Sub cmdClose_Click()
    'Unload form from memory and display
    Unload Me
End Sub


Private Sub cmdHelp_Click()
    ShowHelpTopic 710
End Sub

Private Sub cmdSearch_Click()
    Dim strSearchItem As String
    Dim strSearchString As String
    Dim strSQL As String
    Dim strMsg As String
    
    If cboSearchItem.ListIndex = -1 Then
        strMsg = "Please select the search item from the list provided."
        MsgBox strMsg, vbExclamation, "Missing Input"
    ElseIf Trim(txtSearchString.Text) = "" Then
        strMsg = "Please enter the search item."
        MsgBox strMsg, vbExclamation, "Missing input"
    Else
        strSearchItem = Trim(cboSearchItem.List(cboSearchItem.ListIndex))
        strSearchString = Trim(txtSearchString.Text)
        
        'Source Query
        If TextTheSame(Me.Tag, "External request") Then
            strSQL = "SELECT  * " _
                   & "FROM      [Students] " _
                   & "WHERE     [" & strSearchItem & "] LIKE '" & strSearchString & "' " _
                   & "ORDER BY  Class, Sex, [Surname], [First Names]"
        Else
            strSQL = "SELECT  * " _
                   & "FROM      [Students] " _
                   & "WHERE     [" & strSearchItem & "] LIKE '" & strSearchString & "' " _
                   & "ORDER BY  [" & strSearchItem & "] "
        End If
        
        'Create result recordset
        qryQueryObject.SQL = strSQL
        Set rstSearchResults = qryQueryObject.OpenRecordset
        
        'Check if the search returned any matches
        If rstSearchResults.RecordCount = 0 Then
            strMsg = "No matches where found"
            MsgBox strMsg, vbExclamation, "Search"
            If TextTheSame(Me.Tag, "External request") Then Unload Me
        Else
           frmSearch_Results.Show vbModal
           If TextTheSame(Me.Tag, "External request") Then Unload Me
        End If
    End If

End Sub

Private Sub Form_Activate()
    
    If Loading Then
        Loading = False
        'Check if session is part of an external service request
        If Me.Tag = "External request" Then
            cmdSearch.Value = True
        End If
    End If
            
End Sub

Private Sub Form_Load()
    Loading = True
End Sub

Private Sub Form_Unload(Cancel As Integer)
    On Local Error Resume Next
    frmSystem_MainMenu.SetFocus
End Sub
