VERSION 5.00
Begin VB.Form frmSystem_LogIn 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Log In"
   ClientHeight    =   1740
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5715
   HelpContextID   =   130
   Icon            =   "System Log In.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1740
   ScaleWidth      =   5715
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtUserName 
      Height          =   315
      Left            =   1770
      MaxLength       =   30
      TabIndex        =   0
      ToolTipText     =   "Username goes here"
      Top             =   180
      Width           =   3795
   End
   Begin VB.TextBox txtPassword 
      Height          =   315
      IMEMode         =   3  'DISABLE
      Left            =   1770
      PasswordChar    =   "*"
      TabIndex        =   1
      ToolTipText     =   "Enter your passwor here. Mind the CAPS!"
      Top             =   660
      Width           =   3795
   End
   Begin VB.CommandButton cmdLogIn 
      Caption         =   "Log In"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   300
      TabIndex        =   2
      Top             =   1200
      Width           =   1335
   End
   Begin VB.CommandButton cmdHelp 
      Caption         =   "Help"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   2280
      TabIndex        =   3
      Top             =   1200
      Width           =   1335
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4080
      TabIndex        =   4
      Top             =   1200
      Width           =   1335
   End
   Begin VB.Label Label1 
      Caption         =   "User Name"
      Height          =   195
      Left            =   150
      TabIndex        =   6
      Top             =   240
      Width           =   1755
   End
   Begin VB.Label Label2 
      Caption         =   "Password"
      Height          =   195
      Left            =   150
      TabIndex        =   5
      Top             =   720
      Width           =   1755
   End
End
Attribute VB_Name = "frmSystem_LogIn"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'***********************************************************************
'*                         LOG IN FORM                                 *
'*     Used to log into all the system components. Mantains a variable *
'*     'blnPasswordVerified' which if not set to true before the form  *
'*     is unloaded results in an automatic program termination.        *
'***********************************************************************


Option Explicit

Private blnPasswordVerified As Boolean

Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub cmdHelp_Click()
    ShowHelpTopic 130
End Sub

Private Sub cmdLogIn_Click()
    On Local Error GoTo errorHandler
    Dim strMsg As String
    Dim strExpectedPassword As String
    
    
    txtUserName.Text = Trim(txtUserName.Text)
    
    If txtUserName.Text = "" Then
        MsgBox "Please enter a username first", vbExclamation, "Log In"
        txtUserName.SetFocus
    Else
        'get user's password
        strExpectedPassword = GetUserPassword(txtUserName.Text)
    
        If txtPassword.Text = "" Then
            MsgBox "Please enter a password first", vbExclamation, "Log In"
            txtPassword.SetFocus
        ElseIf txtPassword.Text <> strExpectedPassword Then
            strMsg = "The entered password is incorrect. Remember that passwords " _
                   & "are case sensitive."
            MsgBox strMsg, vbCritical
            txtPassword.Text = ""
            txtPassword.SetFocus
        Else
            InitialiseUserPermissions (txtUserName.Text)
            blnPasswordVerified = True
            Unload Me
        End If
    End If
    
Exit Sub

errorHandler:
    'user not found
    strMsg = "There is no record of an account under that name. " _
           & "Please check that the supplied user name is correct."
    MsgBox strMsg, vbCritical
    txtUserName.SetFocus

End Sub


Private Sub Form_Activate()
    'Give focus on password if calling form has specified a user name
    If txtUserName.Text <> "" Then
        txtPassword.SetFocus
    Else
        txtUserName.SetFocus
    End If
    blnPasswordVerified = False
    
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    'Insurance against any attempt to bypass the form
    If Not blnPasswordVerified Then
        End
    End If
End Sub
